#include <Servo.h>
Servo servo;
int servoPin = 10; // Define the pin for the servo

int ldrPin[] = {A2, A3, A4, A5}; // Define the pins for the ldr's

// all values sensors read
int sensorValue1 = 0; // variable to store the value coming from the sensor
int sensorValue2 = 0;
int sensorValue3 = 0;
int sensorValue4 = 0;

int workValue1 = 0;
int workValue2 = 0;
int workValue3 = 0;
int workValue4 = 0;

int lowValue1 = 20;
int lowValue2 = 40;
int lowValue3 = 10;
int lowValue4 = 15;

int highValue1 = 1023;
int highValue2 = 1023;
int highValue3 = 1023;
int highValue4 = 1023;

const int trigPin = A0; // Define the trigger pin for ultrasonic sensor
const int echoPin = A1; // Define the echo pin for ultrasonic sensor

// Define the pins for motor A
int motorPWMa = 3;
int motorDirA = 12;
int motorBreakA = 9;

// Define the pins for motor B
int motorPWMb = 11;
int motorDirB = 13;
int motorBreakB = 8;

int navCtrl = 0; // Variable used in the state machine. -1 means left, 1 means right, 0 means it executes the rest of the code
boolean seekLight = true; // Variable that decides if the it should steer towards or away from the sun
unsigned long time = millis();


void setup() {
  Serial.begin(9600);
  servo.attach(servoPin); // Attaches the servo object to the servoPin
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  pinMode(motorDirA, OUTPUT) ;
  pinMode(motorBreakA, OUTPUT);
  pinMode(motorDirB, OUTPUT);
  pinMode(motorBreakB, OUTPUT);
}

void loop() {
  switch (navCtrl) {
    case (-1): // Drive backwards and turn left
      if (millis() >= time + 10000) {
        if (millis() >= time + 5000) {
          navCtrl = 0;
        } else {
          left();
        }
      } else {
        backwards();
      }
      break;
    case (1): // Drive backwards and turn right
      if (millis() >= time + 10000) {
        if (millis() >= time + 5000) {
          navCtrl = 0;
        } else {
          right();
        }
      } else {
        backwards();
      }
      break;
    case (0): // Execute ultrasonic sensing
      int dist = ping_cm();
      // if the utrasonic sensor senses an object closer than 20 cm compare the distance to the left and right of the object
      if (dist < 20 && dist != 0) {
        int pingLeft;
        int pingRight;
        servo.write(45);
        delay(1000);
        pingLeft = ping_cm();
        servo.write(135);
        delay(1000);
        pingRight = ping_cm();
        if (pingLeft > pingRight) {
          navCtrl = -1;
        } else {
          navCtrl = 1;
        }
        servo.write(90); // move the servo back to face the front
        delay(1000);
        time = millis();
      } else {
        int side[3];
        int highSide = 0;
        int highValue = 0;

        sensorValue1 = analogRead(ldrPin[0]);
        sensorValue2 = analogRead(ldrPin[1]);
        sensorValue3 = analogRead(ldrPin[2]);
        sensorValue4 = analogRead(ldrPin[3]);

        workValue1 = map(sensorValue1, lowValue1, highValue1, 0, 100);
        workValue2 = map(sensorValue2, lowValue2, highValue2, 0, 100);
        workValue3 = map(sensorValue3, lowValue3, highValue3, 0, 100);
        workValue4 = map(sensorValue4, lowValue4, highValue4, 0, 100);
        Serial.println("sensorValues");
        Serial.println(sensorValue1);
        Serial.println(sensorValue2);
        Serial.println(sensorValue3);
        Serial.println(sensorValue4);

        Serial.println("workValues");
        Serial.println(workValue1);
        Serial.println(workValue2);
        Serial.println(workValue3);
        Serial.println(workValue4);


        if (seekLight) {
          // If seekLight is true, calculate average of the front, left and right side and steer towards the highest value
          side[0] = (workValue1 + workValue2) / 2;
          side[1] = (workValue2 + workValue3) / 2;
          side[2] = (workValue4 + workValue1) / 2;
          //          Serial.println("sides");
          //          Serial.println(side[0]);
          //          Serial.println(side[1]);
          //          Serial.println(side[2]);


        } else {
          // If seekLight is false, calculate average of the back, left and right side and steer away from the highest value
          side[0] = (workValue3 + workValue4) / 2;
          side[1] = (workValue3 + workValue1) / 2;
          side[2] = (workValue2 + workValue3) / 2;
        }
        for (int i = 0; i < sizeof(side) / sizeof(int); i++) {
          //          Serial.println(i);
          if (side[i] > highValue) {
            highSide = i;
            highValue = side[i];
            //            Serial.print("highSide = ");
            //            Serial.println(highSide);
            //            Serial.print("highValue = ");
            //            Serial.println(highValue);
          }
        }
        switch (highSide) {
          case (0):
            forward();
            break;
          case (1):
            right();
            break;
          case (2):
            left();
            break;
        }
      }
      break;
  }
}

int ping_cm() {
  long duration;
  int distance;
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2;
  return distance;
}

void forward() {
  digitalWrite(motorDirA, HIGH); //Establishes forward direction of Channel A
  digitalWrite(motorBreakA, LOW);   //Disengage the Brake for Channel A
  analogWrite(motorPWMa, 255);   //Spins the motor on Channel A at full speed


  digitalWrite(motorDirB, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(motorBreakB, LOW);   //Disengage the Brake for Channel B
  analogWrite(motorPWMb, 255); //Spins the motor on Channel B at full speed
}

void backwards() {
  digitalWrite(motorDirA, LOW); //Establishes backward direction of Channel A
  digitalWrite(motorBreakA, HIGH);   //Disengage the Brake for Channel A
  analogWrite(motorPWMa, 255);   //Spins the motor on Channel A at full speed


  digitalWrite(motorDirB, LOW);  //Establishes backward direction of Channel B
  digitalWrite(motorBreakB, LOW);   //Disengage the Brake for Channel B
  analogWrite(motorPWMb, 255); //Spins the motor on Channel B at full speed

}

void left() {
  digitalWrite(motorDirA, HIGH); //Establishes forward direction of Channel A
  digitalWrite(motorBreakA, LOW);   //Disengage the Brake for Channel A
  analogWrite(motorPWMa, 255);   //Spins the motor on Channel A at full speed


  digitalWrite(motorDirB, HIGH);  //Establishes backward direction of Channel B
  digitalWrite(motorBreakB, HIGH);   //Engage the Brake for Channel B
  analogWrite(motorPWMb, 255); //Spins the motor on Channel B at full speed
}

void right() {
  digitalWrite(motorDirA, HIGH); //Establishes forward direction of Channel A
  digitalWrite(motorBreakA, HIGH);   //Engage the Brake for Channel A
  analogWrite(motorPWMa, 255);   //Spins the motor on Channel A at full speed


  digitalWrite(motorDirB, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(motorBreakB, LOW);   //Disengage the Brake for Channel B
  analogWrite(motorPWMb, 255); //Spins the motor on Channel B at half speed
}

void stop() {
  digitalWrite(motorDirA, HIGH); //Establishes forward direction of Channel A
  digitalWrite(motorBreakA, HIGH);   //Engage the Brake for Channel A
  analogWrite(motorPWMa, 255);   //Spins the motor on Channel A at full speed


  digitalWrite(motorDirB, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(motorBreakB, HIGH);   //Engage the Brake for Channel B
  analogWrite(motorPWMb, 255); //Spins the motor on Channel B at half speed
}
