// Parent class for every component
class Component {
  PVector compPos, compScrPos;
  Component(float _compX, float _compY) {
    compPos = new PVector(_compX, _compY);
    compScrPos = new PVector(0, 0);
  }

  void update() {
    // Calculates absolute screen position after translation and rotation
    float compRadius = sqrt(compPos.x*compPos.x+compPos.y*compPos.y);
    float compAngle = 0;
    if (compPos.x < 0 && compPos.y < 0) {
      compAngle = -PI;
    } else if (compPos.x < 0) {
      compAngle = PI;
    }
    compAngle += seeker.seekerRot + atan(compPos.y/compPos.x);
    compScrPos.set(seeker.seekerPos.x + compRadius * cos(compAngle), seeker.seekerPos.y + compRadius * sin(compAngle));
  }
}
