// This class emulates a light dependent resistor by calculating distance from the mouse //<>//
class LDR extends Component {
  PVector lightPos;
  LDR(float _compX, float _compY) {
    super(_compX, _compY);
    lightPos = new PVector(0, 0);
  }

  void display() {
    pushMatrix();
    translate(compScrPos.x, compScrPos.y);
    rotate(seeker.seekerRot);
    noStroke();
    fill(color(map(analogRead()*0.2, 0, 200, 255, 0), map(analogRead()*0.2, 0, 200, 0, 255), 0));
    circle(0, 0, 10);
    popMatrix();
  }

  void lightUpdate(float lightX, float lightY) {
    // Set the lightposition to input position
    lightPos.set(lightX, lightY);
  }

  int analogRead() {
    // Reads the distance from the LDR to the light position and returns it as a value between 0 and 1023
    int lightLevel = 0;
    lightLevel = 1023 - int(dist(compScrPos.x, compScrPos.y, lightPos.x, lightPos.y));
    lightLevel = constrain(lightLevel, 0, 1023);
    return lightLevel;
  }
}
