/*
Virtual Sun Seeker
 group Cibus
 made for project Smart Environments of CreaTe M02
 */

Seeker seeker;
Sun sun;
Walls walls;

PImage floorTexture;
void setup() {
  fullScreen(P2D);
  frameRate(60);
  noCursor();

  seeker = new Seeker(width/2, height/2);
  sun = new Sun(mouseX, mouseY);
  walls = new Walls();

  floorTexture = loadImage("floorTexture.jpg");
}

void draw() {
  background(floorTexture);
  sun.display();
  walls.display();

  for (int i = 0; i < seeker.ldr.length; i++) {
    seeker.ldr[i].lightUpdate(mouseX, mouseY);
  }
  sun.lightUpdate(mouseX, mouseY);

  seeker.update();
  seeker.display();
}

void keyPressed() {
  //Toggle between driving towards light and away from light
  if (key == ' ') {
    if (seeker.seekLight) {
      seeker.seekLight = false;
    } else {
      seeker.seekLight = true;
    }
  }
}
