// This class contains the walls for the ultrasonic sensor to sense
class Walls {
  PVector[][] wall;
  PImage wallTexture;
  PGraphics wallMask;
  Walls() {
    wall = new PVector[7][5];

    wall[0][0] = new PVector(0, 0);
    wall[0][1] = new PVector(width, 0);
    wall[0][2] = new PVector(width, height*0.05);
    wall[0][3] = new PVector(0, height*0.05);
    wall[0][4] = new PVector(0, 0);

    wall[1][0] = new PVector(width, 0);
    wall[1][1] = new PVector(width, height);
    wall[1][2] = new PVector(width*0.95, height);
    wall[1][3] = new PVector(width*0.95, 0);
    wall[1][4] = new PVector(width, 0);

    wall[2][0] = new PVector(0, height);
    wall[2][1] = new PVector(width, height);
    wall[2][2] = new PVector(width, height*0.95);
    wall[2][3] = new PVector(0, height*0.95);
    wall[2][4] = new PVector(0, height);

    wall[3][0] = new PVector(0, 0);
    wall[3][1] = new PVector(0, height);
    wall[3][2] = new PVector(width*0.05, height);
    wall[3][3] = new PVector(width*0.05, 0);
    wall[3][4] = new PVector(0, 0);

    wall[4][0] = new PVector(0, 0);
    wall[4][1] = new PVector(width*0.4, 0);
    wall[4][2] = new PVector(width*0.3, height*0.3);
    wall[4][3] = new PVector(0, height*0.4);
    wall[4][4] = new PVector(0, 0);

    wall[5][0] = new PVector(width*0.7, height*0.7);
    wall[5][1] = new PVector(width, height*0.6);
    wall[5][2] = new PVector(width, height);
    wall[5][3] = new PVector(width*0.6, height);
    wall[5][4] = new PVector(width*0.7, height*0.7);

    wall[6][0] = new PVector(width*0.3, height*0.55);
    wall[6][1] = new PVector(width*0.4, height*0.65);
    wall[6][2] = new PVector(width*0.3, height*0.75);
    wall[6][3] = new PVector(width*0.2, height*0.65);
    wall[6][4] = new PVector(width*0.3, height*0.55);

    // Create a texture fill for the walls
    wallTexture = loadImage("wallTexture.jpg");
    wallMask = createGraphics(width, height);
    wallMask.beginDraw();
    wallMask.noStroke();
    for (int i = 0; i < wall.length; i++) {
      wallMask.beginShape();
      for (int j = 0; j < wall[i].length-1; j++) {
        wallMask.vertex(wall[i][j].x, wall[i][j].y);
      }
      wallMask.endShape(CLOSE);
    }
    wallMask.endDraw();
    wallTexture.mask(wallMask);
  }

  void display() {
    image(wallTexture, 0, 0);
  }
}
