LDR[] ldrs;
int x, y;

void setup() {
  size(1280, 720);

  ldrs = new LDR[4];
  ldrs[0] = new LDR(200, 300);
  ldrs[1] = new LDR(400, 300);
  ldrs[2] = new LDR(400, 600);
  ldrs[3] = new LDR(200, 600);

  x = 300;
  y = 450;
}

void draw() {
  background(255);
  for (LDR l : ldrs) {
    l.update();
  }

  int[] values = new int[4];
  for (int i=0; i<ldrs.length; i++) {
    values[i] = ldrs[i].getValue();
  }
  LDRCheck(values);
}

void LDRCheck(int[] val) {
  float ldr0 = map(val[0], 0, 1023, 0, 50);
  float ldr1 = map(val[1], 0, 1023, 0, 50);
  float ldr2 = map(val[2], 0, 1023, 0, 50);
  float ldr3 = map(val[3], 0, 1023, 0, 50);

  float top = (ldr0 + ldr1)*5;
  float bottom = (ldr2 + ldr3)*5;
  float left = (ldr0 + ldr3)*6;
  float right = (ldr1 + ldr2)*6;

  stroke(150, 0, 200);
  line(x, y, x, y-top);
  line(x, y, x+right, y);
  line(x, y, x, y+bottom);
  line(x, y, x-left, y);

  

  float sunX = ((val[1] + val[2]) - (val[0] + val[3]))*0.12;
  float sunY = ((val[2] + val[3]) - (val[0] + val[1]))*0.1;

  stroke(255, 0, 0);
  line(x, y, x + 4*sunX, y + 4*sunY);
}
